
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/complete.hh>
%}
%define alg_complete_interface(Automaton, GenAutomaton, Series, Exp, HList)
static void complete_here(Automaton& a) ;
static void complete_here(GenAutomaton& a) ;
static Automaton complete(const Automaton& a) ;
static GenAutomaton complete(const GenAutomaton& a) ;
static bool is_complete(const Automaton& a) ;
static bool is_complete(const GenAutomaton& a) ;
%enddef
%define alg_complete_interface_impl(Automaton, GenAutomaton, Series, Exp, HList)
static  void complete_here(Automaton& a) { return vcsn::complete_here(*a); }
static  void complete_here(GenAutomaton& a) { return vcsn::complete_here(*a); }
static  Automaton complete(const Automaton& a) { return vcsn::complete(*a); }
static  GenAutomaton complete(const GenAutomaton& a) { return vcsn::complete(*a); }
static  bool is_complete(const Automaton& a) { return vcsn::is_complete(*a); }
static  bool is_complete(const GenAutomaton& a) { return vcsn::is_complete(*a); }
%enddef
%define alg_interface_complete(Kind)
%{
struct Kind ##_alg_complete {
alg_complete_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_set_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
%enddef
%define decl_alg_complete(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_complete {
alg_complete_interface_impl(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_set_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
struct Kind ##_alg_complete {
alg_complete_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_set_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%enddef
