
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/thompson.hh>
%}
%define alg_thompson_interface(Automaton, GenAutomaton, Series, Exp, HList)
static void thompson_of(Automaton& a, const Exp& e) ;
static void thompson_of(GenAutomaton& a, const Exp& e) ;
%enddef
%define alg_thompson_interface_impl(Automaton, GenAutomaton, Series, Exp, HList)
static  void thompson_of(Automaton& a, const Exp& e) { return vcsn::thompson_of(*a, e.value()); }
static  void thompson_of(GenAutomaton& a, const Exp& e) { return vcsn::thompson_of(*a, e.value()); }
%enddef
%define alg_interface_thompson(Kind)
%{
struct Kind ##_alg_thompson {
alg_thompson_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_set_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
%enddef
%define decl_alg_thompson(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_thompson {
alg_thompson_interface_impl(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_set_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
struct Kind ##_alg_thompson {
alg_thompson_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_set_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%enddef
